package cn.ibizlab.businesscentral.core.odoo_digest.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_digest.domain.Digest_digest;
import cn.ibizlab.businesscentral.core.odoo_digest.filter.Digest_digestSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Digest_digestMapper extends BaseMapper<Digest_digest>{

    Page<Digest_digest> searchDefault(IPage page, @Param("srf") Digest_digestSearchContext context, @Param("ew") Wrapper<Digest_digest> wrapper) ;
    @Override
    Digest_digest selectById(Serializable id);
    @Override
    int insert(Digest_digest entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Digest_digest entity);
    @Override
    int update(@Param(Constants.ENTITY) Digest_digest entity, @Param("ew") Wrapper<Digest_digest> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Digest_digest> selectByTemplateId(@Param("id") Serializable id) ;

    List<Digest_digest> selectByCompanyId(@Param("id") Serializable id) ;

    List<Digest_digest> selectByCreateUid(@Param("id") Serializable id) ;

    List<Digest_digest> selectByWriteUid(@Param("id") Serializable id) ;


}
